// u_35_generic_procedure_of_object
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_35_generic_procedure_of_object;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    notify_addition_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure notify_addition_Click(Sender: TObject);
    procedure bClick(Sender: TObject);
    procedure eClick(Sender: TObject);
    procedure dClick(Sender: TObject);
    procedure cClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_display_simple
      , u_c_storage
      ;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        Left:= 170; Top:= 110;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    Type c_statistics=
             Class
               m_c_storage: c_storage<Integer>;

               constructor create_statistics;
               procedure display_value_changed(p_value: Integer);
               procedure display_storage_changed(p_c_storage: c_storage<Integer>);
             end; // c_storage

    // -- Type c_statistics

    constructor c_statistics.create_statistics;
      begin
        Inherited Create;

        m_c_storage:= c_storage<Integer>.create_storage(5);

        m_c_storage.m_on_notify_value_changed:= display_value_changed;
        m_c_storage.m_on_notify_storage_changed:= display_storage_changed;
      end; // create_statistics

    procedure c_statistics.display_value_changed(p_value: Integer);
      begin
        display('added_value '+ IntToStr(p_value));
      end; // display_value_changes

    procedure c_statistics.display_storage_changed(p_c_storage: c_storage<Integer>);
      var l_index: Integer;
      begin
        display('added_value_to ');
        for l_index:= 0 to Length(p_c_storage.m_table)- 1 do
          display('  '+ IntToStr(p_c_storage.m_table[l_index]));
      end; // display_storage_changed

    var g_c_statistics: c_statistics;

    procedure TForm1.notify_addition_Click(Sender: TObject);
      begin
        g_c_statistics:= c_statistics.create_statistics;
        g_c_statistics.m_c_storage.add_value(0, 33);
      end; // notify_addition_Click

    procedure TForm1.bClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.cClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.dClick(Sender: TObject);
      begin
      end; //

    procedure TForm1.eClick(Sender: TObject);
      begin
      end; //

    end.

