// u_35_generic_procedure_of_object
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_storage;
  interface

    type t_po_notify_change<T>= Procedure(p_value: T) Of Object;

         c_storage<V>=
             Class
               m_table: array of V;

               m_on_notify_value_changed: t_po_notify_change<V>;
               m_on_notify_storage_changed: t_po_notify_change< c_storage<V> >;

               constructor create_storage(p_size: Integer);
               procedure add_value(p_index: Integer; p_value: V);
             end; // c_storage

  implementation

    // -- Type c_storage<V>

    constructor c_storage<V>.create_storage(p_size: Integer);
      begin
        Inherited Create;
        SetLength(m_table, p_size);
      end; // create_storage

    procedure c_storage<V>.add_value(p_index: Integer; p_value: V);
      begin
        m_table[p_index]:= p_value;

        if Assigned(m_on_notify_value_changed)
          then m_on_notify_value_changed(p_value);

        if Assigned(m_on_notify_storage_changed)
          then m_on_notify_storage_changed(Self);
      end; // add_value

    end. // u_c_storage


